﻿
#Область ОписаниеПеременных

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

#КонецОбласти

#Область ОбработчикиСобытийФормы

// Предопределенный метод
// 
&НаСервере
Процедура ПриСозданииНаСервере(Отказ, СтандартнаяОбработка)
	
	Если НЕ исперп_Настройка.АдминистрированиеДоступно() Тогда
		Сообщение	= Новый СообщениеПользователю;
		Сообщение.Текст	= НСтр("ru = 'Изменение настроек доступно только администраторам. Обратитусь в техподдержку.'", "");
		Сообщение.Сообщить(); 
		Отказ	= Истина;
		Возврат;
	КонецЕсли;
	
	КонфигурацияЗаполнитьНаСервере();
	ТаблицаПравкиЗаполнитьНаСервере();
	ЭлементыПараметрыУстановитьНаСервере();
	
КонецПроцедуры

#КонецОбласти

#Область ОбработчикиКомандФормы

// Записывает настройку и закрывает форму
// 
&НаКлиенте
Процедура ЗаписатьИЗакрыть(Команда)
	
	Настройка	= Новый Соответствие();
	Для Каждого ПравкиСтрока Из ТаблицаПравки Цикл
		Настройка.Вставить(ПравкиСтрока.Идентификатор, ПравкиСтрока.Включена);
	КонецЦикла;
	НастройкаСохранитьНаСервере(Настройка);
	
	ЭтотОбъект.Закрыть();
		
КонецПроцедуры

#КонецОбласти 

#Область ОбработчикиСобытийЭлементовШапкиФормы

#КонецОбласти 

#Область ОбработчикиСобытийЭлементовТаблицыФормыТаблицаПродажи

// При активации строки ТаблицаПродажи. Выводит 
&НаКлиенте
Процедура ТаблицаПравкиПриАктивизацииСтроки(Элемент)
	
	ДанныеТекущие	= Элементы.ТаблицаПравки.ТекущиеДанные;
	
	Если ДанныеТекущие <> Неопределено Тогда
		ЭтотОбъект.ПравкаТекст	= ДанныеТекущие.Текст;
		ЭтотОбъект.ПравкаМетоды	= ДанныеТекущие.Методы;
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти 

#Область СлужебныеПроцедурыИФункции

// Сохраняет настройку активности правок
//
// Параметры: 
// 	Настройка - Соответствие - Сохраняемая настройка
//
&НаСервереБезКонтекста
Процедура НастройкаСохранитьНаСервере(Настройка)
	
	Для Каждого Элемент Из Настройка Цикл
		исперп_Настройка.ПравкаИспользовать(Элемент.Ключ, Элемент.Значение);
	КонецЦикла;
	
КонецПроцедуры // НастройкаСохранитьНаСервере 

// Устанавливает параметры элементов формы
//
// Параметры: 
//
&НаСервере
Процедура ЭлементыПараметрыУстановитьНаСервере()
	
	Совместимо	= исперп_Конфигурация.Совместима();
	Элементы.ДекорацияКонфигурацияСовместимостьОтсутствует.Видимость	= НЕ Совместимо;
	Элементы.ТаблицаПравки.ТолькоПросмотр								= НЕ Совместимо;
	
КонецПроцедуры // ЭлементыПараметрыУстановитьНаСервере 

// Заполняет сведения о конфигурации
//
// Параметры: 
//
&НаСервере
Процедура КонфигурацияЗаполнитьНаСервере()
	
	ЭтотОбъект.КонфигурацияИмя		= исперп_Конфигурация.Идентификатор();
	ЭтотОбъект.КонфигурацияВерсия	= исперп_Конфигурация.Версия();
	
КонецПроцедуры // КонфигурацияЗаполнитьНаСервере 

// Заполняет ТаблицаПравки
//
// Параметры: 
//
&НаСервере
Процедура ТаблицаПравкиЗаполнитьНаСервере()
	
	ТаблицаПравки.Очистить();
	
	Версия	= ЭтотОбъект.КонфигурацияВерсия;
	
	Для Каждого Правка Из исперп_Состав.Получить() Цикл
		
		Идентификатор	= исперп_Описание.Идентификатор(Правка);
		ПравкиСтрока	= ТаблицаПравки.Добавить();
		ПравкиСтрока.Идентификатор	= исперп_Описание.Идентификатор(Правка);
		ПравкиСтрока.Вид			= исперп_Описание.Вид(Правка);
		ПравкиСтрока.Область		= исперп_Описание.Область(Правка);
		ПравкиСтрока.ВерсияМин		= исперп_Описание.ВерсияМин(Правка);
		ПравкиСтрока.ВерсияМакс		= исперп_Описание.ВерсияМакс(Правка);
		ПравкиСтрока.Текст			= исперп_Описание.Текст(Правка);
		ПравкиСтрока.Методы			= исперп_Описание.Методы(Правка);
		ПравкиСтрока.Доступна		= КонфигурацияПравкаДоступна(Версия, ПравкиСтрока.ВерсияМин, ПравкиСтрока.ВерсияМакс);
		ПравкиСтрока.Включена		= ПравкиСтрока.Доступна И исперп_Правка.Включена(Идентификатор);
		
	КонецЦикла;
	
КонецПроцедуры // ТаблицаПравкиЗаполнитьНаСервере 

// Истина, если версия правки совместима с конфигурацией
//
// Параметры: 
// 	Версия - Строка - Версия конфигурации
// 	ВерсияМин - Строка - Минималь допустимая версия
// 	ВерсияМакс - Строка - Максимально допустимая версия
//
// Возвращаемое значение: 
// 	Булево
//
&НаКлиентеНаСервереБезКонтекста
Функция КонфигурацияПравкаДоступна(Версия, ВерсияМин, ВерсияМакс)
	
	Возврат (ПустаяСтрока(ВерсияМин) ИЛИ исперп_Версия.Сравнить(Версия, ВерсияМин, СтрЧислоВхождений(ВерсияМин, ".") + 1) >= 0)
	И (ПустаяСтрока(ВерсияМакс) ИЛИ исперп_Версия.Сравнить(Версия, ВерсияМакс, СтрЧислоВхождений(ВерсияМакс, ".") + 1) <= 0);
	
КонецФункции // ПравкаВерсияСовместима 

#КонецОбласти
